<template>
  <div class="full-container-p24">
    <div style="display: flex; justify-content: space-between">
      <div style="display: flex">
        <el-input
          placeholder="请输入部门"
          prefix-icon="el-icon-search"
          v-model="term"
          clearable
          style="height: 32px; width: 330px; line-height: 32px"
          @keyup.enter="getDepartmentList"
        ></el-input>
        <div class="seach-btn" @click="getDepartmentList">查询</div>
      </div>
      <el-button
        v-auth="'ADDUPDATEDEPT'"
        type="primary"
        @click="visable = true"
      >
        添加部门
      </el-button>
    </div>

    <el-dialog
      v-model="visable"
      :title="deptId ? '修改部门' : '添加部门'"
      width="550px"
      @close="resetForm()"
    >
      <template v-slot:default>
        <div class="df jcc">
          <el-form
            :model="ruleForm"
            :rules="rules"
            ref="form"
            label-width="110px"
            label-position="left"
          >
            <el-form-item prop="name" label="部门名称">
              <el-input
                style="width: 280px"
                v-model="ruleForm.deptName"
              ></el-input>
            </el-form-item>
          </el-form>
        </div>
      </template>
      <template v-slot:footer>
        <div class="dialog-footer">
          <el-button @click="resetForm">取 消</el-button>
          <el-button type="primary" @click="addDepartment(ruleForm)">
            确 定
          </el-button>
        </div>
      </template>
    </el-dialog>

    <div style="margin-top: 24px">
      <el-table :data="tableData" stripe style="width: 100%">
        <el-table-column
          type="index"
          label="序号"
          min-width="40"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="departmentName"
          label="部门名称"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="createTime"
          label="创建时间"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          v-auth="'ADDUPDATEDEPT'"
          label="操作"
          min-width="120"
          align="center"
        >
          <template v-slot="scope">
            <div class="df aic jcsa">
              <!-- <el-switch
                v-model="scope.row.accountStatus"
                active-color="#13ce66"
                inactive-color="#ff4949"
                active-text="启用"
                inactive-text="禁用"
                :active-value="1"
                :inactive-value="0"
              />

              <div
                style="
                  color: red;
                  margin-left: 10px;
                  font-size: 14px;
                  text-decoration: underline;
                  cursor: pointer;
                "
              >
                删除
              </div> -->
              <el-button
                @click="showUpdateModal(scope.row)"
                size="small"
                type="primary"
              >
                修改部门
              </el-button>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div style="width: 100%; text-align: right; margin-top: 43px">
        <el-pagination
          background
          layout="prev, pager, next"
          :total="total"
          @current-change="pageChange"
        ></el-pagination>
      </div>
    </div>
  </div>
</template>

<script setup>
import api from "../../apis/fetch";
import { ref, onMounted, reactive } from "vue";
import { ElNotification, ElMessageBox } from "element-plus";

let tableData = ref([]);
let currentPage = ref(1);
let total = ref(0);
let term = ref("");
let loginAccountId = ref(0);
let deptId = ref("");
let ruleForm = ref({
  deptName: "",
});
const rules = reactive({
  deptName: [
    {
      required: true,
      message: "请填写部门名称",
      trigger: "blur",
    },
  ],
});

async function getDepartmentList() {
  let res = await api.getDepartmentList({
    term: term.value,
    currentPage: currentPage.value,
    size: 10,
    loginAccountId: loginAccountId.value,
  });
  if (res.data.status == 0) {
    tableData.value = res.data.result;
    for (let i of tableData.value) {
      if (i.roleId == 0) {
        i.roleId = "";
      }
    }
    total.value = res.data.total;
  } else {
    tableData.value = [];
    total.value = 0;
  }
}

function pageChange(e) {
  currentPage.value = e;
  getDepartmentList();
}
let visable = ref(false);
let form = ref(null);
async function addDepartment() {
  let postData = {
    ...ruleForm.value,
    loginAccountId: loginAccountId.value,
  };
  if (deptId.value) {
    postData.deptId = deptId.value;
  }
  let res = await api[deptId.value ? "updateDepartment" : "addDepartment"](
    postData
  );
  let status = res.data.status == 0;
  ElNotification({
    title: status ? "成功" : "失败",
    duration: 1500,
    message: res.data.msg,
    type: status ? "success" : "error",
  });
  resetForm();
  getDepartmentList();
}
function resetForm() {
  visable.value = false;
  deptId.value = "";
  ruleForm.value = {
    deptName: "",
  };
  form.value.resetFields();
}

function showUpdateModal(item) {
  visable.value = true;
  deptId.value = item.id;
  ruleForm.value = {
    deptName: item.departmentName,
  };
}

onMounted(() => {
  loginAccountId.value = localStorage.loginAccountId;
  getDepartmentList();
});
</script>

<style scoped>
.seach-btn {
  display: inline-block;
  width: 60px;
  height: 38px;
  background: #0094fe;
  border-radius: 2px;
  font-size: 14px;
  font-family: PingFangSC-Regular, PingFang SC;
  font-weight: 400;
  color: #ffffff;
  text-align: center;
  line-height: 38px;
  margin-left: 10px;
  cursor: pointer;
}
</style>
